"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/create-request.ts
var create_request_exports = {};
__export(create_request_exports, {
  createRequest: () => createRequest
});
module.exports = __toCommonJS(create_request_exports);
var import_isFunction = __toESM(require("lodash/isFunction"));
var import_cross_fetch = require("cross-fetch");
var import_merge = __toESM(require("lodash/merge"));

// src/utils.ts
var headersToObject = (headers) => {
  const acc = {};
  for (const p of headers.entries()) {
    acc[p[0]] = p[1];
  }
  return acc;
};

// src/create-request.ts
var buildUrl = (targetUrl, query, base) => {
  const newUrl = new URL(targetUrl, base || "http://example.com");
  if (query) {
    Object.entries(query).forEach(
      ([k, v]) => newUrl.searchParams.append(k, v)
    );
  }
  if (!targetUrl.startsWith("http") && !base) {
    return newUrl.pathname + newUrl.search + newUrl.hash;
  }
  return newUrl.toString();
};
var createRequest = ({ ep, config }, {
  method,
  params,
  data,
  query,
  baseOpts,
  opts
}) => {
  const headers = new import_cross_fetch.Headers({
    "Content-Type": "application/json"
  });
  if (config == null ? void 0 : config.basic) {
    headers.set(
      "Authorization",
      `Basic ${btoa(`${config.basic.user}:${config.basic.password}`)}`
    );
  }
  if (config == null ? void 0 : config.bearer) {
    headers.set("Authorization", `Bearer ${config.bearer}`);
  }
  const customopts = {};
  customopts.headers = headersToObject(headers);
  const producedUrl = (0, import_isFunction.default)(ep) ? ep(params) : ep;
  const targetUrl = buildUrl(producedUrl, query, config == null ? void 0 : config.base);
  return {
    url: targetUrl,
    body: data ? JSON.stringify(data) : void 0,
    method,
    opts: (0, import_merge.default)({}, baseOpts, customopts, opts)
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createRequest
});
