"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  createMethod: () => createMethod,
  funfetch: () => funfetch
});
module.exports = __toCommonJS(src_exports);
var import_cross_fetch2 = __toESM(require("cross-fetch"));
var import_debug = __toESM(require("debug"));

// src/create-request.ts
var import_isFunction = __toESM(require("lodash/isFunction"));
var import_cross_fetch = require("cross-fetch");
var import_merge = __toESM(require("lodash/merge"));

// src/utils.ts
var headersToObject = (headers) => {
  const acc = {};
  for (const p of headers.entries()) {
    acc[p[0]] = p[1];
  }
  return acc;
};

// src/create-request.ts
var buildUrl = (targetUrl, query, base) => {
  const newUrl = new URL(targetUrl, base || "http://example.com");
  if (query) {
    Object.entries(query).forEach(
      ([k, v]) => newUrl.searchParams.append(k, v)
    );
  }
  if (!targetUrl.startsWith("http") && !base) {
    return newUrl.pathname + newUrl.search + newUrl.hash;
  }
  return newUrl.toString();
};
var createRequest = ({ ep, config }, {
  method,
  params,
  data,
  query,
  baseOpts,
  opts
}) => {
  const headers = new import_cross_fetch.Headers({
    "Content-Type": "application/json"
  });
  if (config == null ? void 0 : config.basic) {
    headers.set(
      "Authorization",
      `Basic ${btoa(`${config.basic.user}:${config.basic.password}`)}`
    );
  }
  if (config == null ? void 0 : config.bearer) {
    headers.set("Authorization", `Bearer ${config.bearer}`);
  }
  const customopts = {};
  customopts.headers = headersToObject(headers);
  const producedUrl = (0, import_isFunction.default)(ep) ? ep(params) : ep;
  const targetUrl = buildUrl(producedUrl, query, config == null ? void 0 : config.base);
  return {
    url: targetUrl,
    body: data ? JSON.stringify(data) : void 0,
    method,
    opts: (0, import_merge.default)({}, baseOpts, customopts, opts)
  };
};

// src/index.ts
var debug = (0, import_debug.default)("funfetch");
var noop = (_res) => {
};
var fullResponseJsonHandler = (x) => __async(void 0, null, function* () {
  const { headers } = x;
  const contentType = headers.get("Content-Type");
  if (contentType == null ? void 0 : contentType.includes("application/json")) {
    return {
      body: yield x.json(),
      status: x.status,
      headers: headersToObject(x.headers)
    };
  }
  return {
    body: yield x.text(),
    status: x.status,
    headers: headersToObject(x.headers)
  };
});
var simpleResponseJsonHandler = (x) => __async(void 0, null, function* () {
  const { headers } = x;
  const contentType = headers.get("Content-Type");
  if (contentType == null ? void 0 : contentType.includes("application/json")) {
    return yield x.json();
  }
  return yield x.text();
});
var throwIfBadStatus = (response) => {
  if (response.status >= 400 && response.status < 600) {
    throw new Error(JSON.stringify(response));
  }
};
var createMethod = (method, config) => (ep) => (..._0) => __async(void 0, [..._0], function* ({
  params,
  data,
  query,
  opts
} = {}) {
  const fetcher = (config == null ? void 0 : config.fetch) || import_cross_fetch2.default;
  const req = createRequest(
    { ep, config },
    { method, params, data, query, opts, baseOpts: config == null ? void 0 : config.baseOpts }
  );
  debug("request: %j", req);
  const res = yield fetcher(req.url, __spreadValues({
    method: req.method,
    body: req.body
  }, req.opts));
  const throwIfBad = (config == null ? void 0 : config.throwIfBadStatus) || throwIfBadStatus;
  throwIfBad(res);
  const convertedResponse = yield ((config == null ? void 0 : config.responseHandler) || ((config == null ? void 0 : config.fullResponse) ? fullResponseJsonHandler : simpleResponseJsonHandler))(res);
  debug("response: %O", convertedResponse);
  const throwIfError = (config == null ? void 0 : config.throwIfError) || noop;
  throwIfError(convertedResponse);
  debug("done: (no errors)");
  return convertedResponse;
});
var funfetch = (config = {}) => {
  return {
    post: createMethod("POST", config),
    get: createMethod("GET", config),
    put: createMethod("PUT", config),
    del: createMethod("DELETE", config)
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createMethod,
  funfetch
});
